% Sample
%   :PROPERTIES:
%   :header-args:matlab+: :tangle src/initializeSample.m
%   :header-args:matlab+: :comments org :mkdirp yes
%   :header-args:matlab+: :eval no :results none
%   :END:
%   <<sec:initializeSample>>

% This Matlab function is accessible [[file:src/initializeSample.m][here]].


function [sample] = initializeSample(opts_param)
    %% Default values for opts
    sample = struct('radius', 100, ...
                    'height', 300, ...
                    'mass',   50,  ...
                    'offset', 0,   ...
                    'color',  [0.45, 0.45, 0.45] ...
    );

    %% Populate opts with input parameters
    if exist('opts_param','var')
        for opt = fieldnames(opts_param)'
            sample.(opt{1}) = opts_param.(opt{1});
        end
    end

    %%
    sample.k.x = 1e8;
    sample.c.x = sqrt(sample.k.x*sample.mass)/10;

    sample.k.y = 1e8;
    sample.c.y = sqrt(sample.k.y*sample.mass)/10;

    sample.k.z = 1e8;
    sample.c.z = sqrt(sample.k.y*sample.mass)/10;

    %% Save
    save('./mat/stages.mat', 'sample', '-append');
end
